# rooms.py

# Copyright (C) 2019 Hannu Viitala
#
# The source code in this file is released under the MIT license.
# Go to http://opensource.org/licenses/MIT for the full license details.
#

import globals as glob
import data
import gc

#gc.collect()
#print ("free, before rooms",gc.mem_free())

# roomParameters
glob.roomParameters2 = (
    (), # room0
    (), # room1
    (), # room2
    (), # room3
    
    ( # *** room4
        
        "Beehive",
        
         # Tile definitions
        (
            # id  bitmap               flags
            0x0, data.backgroundSurf0, 0,
            0x1, data.wallSurf1,      glob.TILE_FLAG_BLOCKING,
            0x6, data.floorSurf1, glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_PLATFORM,
            0x7, data.backgroundSurf1,      glob.TILE_FLAG_BLOCKING,
            0xf, data.backgroundSurf5, glob.TILE_FLAG_EXIT_GATE, 
        ),

        # Exit triggers
        (
            # id, newRoom,   newX,                   newY 
            0xf,       5,  8,  -999
        ),
        
        # Sprites
        (
            
            # Bee 0
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            0, 10,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\xff\x01\x00\x01\x02\x02\x01\x00\x00\x00',

            # Bee 1
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60, 10,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\xff\x01\x00\x01\x02\x02\x01\x00\x00\x00',

            # Bee queen
            # Bitmaps
            (
                # bitmap         offset
                data.beeQueenSurf_f1, (0,0), 
                data.beeQueenSurf_f2, (0,0),
            ),
            # wx, wy,  bx1,   by1,   bx2,    by2
            105, 80,  105,  -999,    130,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\xff\x01\x00\x01\x02\x03\x00\x00\x00\x00',

            # Juice
            # Bitmaps
            (
                # bitmap         offset
                data.honeyPotSurf0, (0,0), 
                data.honeyPotSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            8+(15*8),  28+(9*8),  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',
        ),
    ),
    ( # *** room5
        
        "Nightmare begins",
        
        # Tile definitions
        (
            # id  bitmap               flags
            0x0, data.backgroundSurf0, 0,
            0x1, data.wallSurf1,      glob.TILE_FLAG_BLOCKING,
            0x7, data.backgroundSurf1, 0,
            0xC, data.floorSurf0,      glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_PLATFORM,
            0xe, data.backgroundSurf5,      glob.TILE_FLAG_EXIT_GATE,
            0xf, data.backgroundSurf5,      glob.TILE_FLAG_EXIT_GATE,
        ),

        # Exit triggers
        (
            # id, newRoom,   newX,                   newY 
            0xe,       4,  (8*glob.TILEMAP_W)-16,  -999,
            0xf,       6,                8,  -999
        ),
        
       # Sprites
        (           
            # Scissors
            # Bitmaps
            (
                # bitmap         offset
                data.scissorsSurf0, (-2,0), 
                data.scissorsSurf1, (2,0),
                data.scissorsSurf2, (0,0), 
                data.scissorsSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60,   10,  -999,     0,   999,  14*8,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\xff\x00\x01\x01\x03\x02\x00\x00\x00\x00',

            # Clock
            # Bitmaps
            (
                # bitmap         offset
                data.clockSurf0, (0,0), 
                data.clockSurf1, (0,0),
                data.clockSurf2, (0,0), 
                data.clockSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            20,  17,  20,  -999,    90,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\xff\x01\x00\x01\x02\x03\x00\x00\x00\x00',

            # Juice 0
            # Bitmaps
            (
                # bitmap         offset
                data.juiceSurf0, (0,0), 
                data.juiceSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            9,  44,  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',

            # Juice 1
            # Bitmaps
            (
                # bitmap         offset
                data.juiceSurf0, (0,0), 
                data.juiceSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            128,  20,  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',
        ),
    ),
    ( # *** room6
        
        "The worst mare!",
        
        # Tile definitions
        (
            # id  bitmap               flags
            0x0, data.backgroundSurf0, 0,
            0x9, data.backgroundSurf2, 0,
            0xF, data.floorSurf3, glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_PLATFORM,
            0x5, data.floorSurf3,      glob.TILE_FLAG_BLOCKING,
            0xe, data.backgroundSurf5,  glob.TILE_FLAG_EXIT_GATE, 
            0xd, data.floorSurf3,glob.TILE_FLAG_EXIT_GATE, 
            0x6, data.lockedDoorSurf, glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_LOCKED_GATE, # locked door
        ),

        # Exit triggers
        (
            # id, newRoom,   newX,                   newY 
            0xe,       5,  (8*glob.TILEMAP_W)-16,  -999,
            0xd,       7,                      8,  -999,
            0x6,       9,                   -999,     8
        ),
        
        # Sprites
        (           
            # Spider 0
            # Bitmaps
            (
                # bitmap         offset
                data.spiderSurf_f0, (1,0), 
                data.spiderSurf_f1, (1,0),
                data.spiderSurf_f2, (1,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            40, 95,    0,  -999,    180,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\xff\x01\x00\x01\x04\x05\x01\x01\x00\x00',

            # Spider 1
            # Bitmaps
            (
                # bitmap         offset
                data.spiderSurf_f0, (1,0), 
                data.spiderSurf_f1, (1,0),
                data.spiderSurf_f2, (1,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            100, 95,    0,  -999,   180,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\xff\x01\x00\x01\x04\x05\x01\x01\x00\x00',

            # Spider 2
            # Bitmaps
            (
                # bitmap         offset
                data.spiderSurf_f0, (1,0), 
                data.spiderSurf_f1, (1,0),
                data.spiderSurf_f2, (1,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            160, 95,      0,  -999,   180,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\xff\x01\x00\x01\x04\x05\x01\x01\x00\x00',

            # Zombi 0
            # Bitmaps
            (
                # bitmap         offset
                data.annabelleSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            30, 60,    -999,    0,   999,    120,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\xff\x00\x01\x01\x03\x03\x00\x00\x00\x00',

            # Zombi 1
            # Bitmaps
            (
                # bitmap         offset
                data.annabelleSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60, 40,    -999,    0,   999,    120,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x04\xff\x00\x01\x01\x03\x03\x00\x00\x00\x00',

            # Zombi 2
            # Bitmaps
            (
                # bitmap         offset
                data.annabelleSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            90,  20,    -999,    0,   999,    120,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x05\xff\x00\x01\x01\x03\x03\x00\x00\x00\x00',

            # Juice
            # Bitmaps
            (
                # bitmap         offset
                data.juiceSurf0, (0,0), 
                data.juiceSurf1, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            9,  36,    -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x06\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',
        ),
    ),
    ( # *** room7
        
        "Tor's horror bees",
        
        # Tile definitions
        (
            # id  bitmap               flags
            0x0, data.backgroundSurf0, 0,
            0x6, data.floorSurf1,      glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_PLATFORM,
            0x7, data.backgroundSurf1, 0,
            0xe, data.floorSurf1,      glob.TILE_FLAG_BLOCKING,
            0xf, data.backgroundSurf5, glob.TILE_FLAG_EXIT_GATE, 
        ),

        # Exit triggers
        (
            # id, newRoom,   newX,                   newY 
            0xf,  5,         (8*glob.TILEMAP_W)-16,  -999,
        ),
        
        # Sprites
        (
            
            # Bee 0
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60,   10,  -16,   -999,     20*8,  999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\xff\x01\x00\x01\x04\x02\x01\x01\x00\x00',

            # Bee 1
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            40,   30,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\xff\x01\x00\x01\x04\x02\x01\x01\x00\x00',

            # Bee 2
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,   bx2,    by2
            50,   50,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\xff\x01\x00\x01\x04\x02\x01\x01\x00\x00',

            # Bee 3
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            30, 70,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\xff\x01\x00\x01\x04\x02\x01\x01\x00\x00',

            # Bee 4
            # Bitmaps
            (
                # bitmap         offset
                data.beeSurf_f1, data.beeSurfOffset_f1, 
                data.beeSurf_f2, data.beeSurfOffset_f2,
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            70, 90,  -16,  -999,   20*8,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x04\xff\x01\x00\x01\x04\x02\x01\x01\x00\x00',

            # honey 0
            # Bitmaps
            (
                # bitmap         offset
                data.honeyPotSurf0, (0,0), 
                data.honeyPotSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            64,  53,  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x05\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',

            # honey 1
            # Bitmaps
            (
                # bitmap         offset
                data.honeyPotSurf0, (0,0), 
                data.honeyPotSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60,  65,  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x06\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',

            # honey 2
            # Bitmaps
            (
                # bitmap         offset
                data.honeyPotSurf0, (0,0), 
                data.honeyPotSurf1, (0,0),
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            69,  65,  -999,  -999,   999,   999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x07\xff\x00\x00\x01\x02\x01\x00\x00\x00\x01',

        ),
    ),
    
    (), # room0
    
    ( # *** room9
        
        "Giant feet fleet",
        
        # Tile definitions
        (
            # id  bitmap               flags
            0x4, data.wallSurf2, glob.TILE_FLAG_BLOCKING | glob.TILE_FLAG_PLATFORM,
            0xf, data.backgroundSurf4, 0,
            0xd, data.backgroundSurf0,0,
            0xa, data.backgroundSurf0, glob.TILE_FLAG_TRIGGER,
            0xc, data.wallSurf2, glob.TILE_FLAG_BLOCKING,
        ),

        # Exit triggers
        (
        ),
        
        # Sprites
        (        
            # big foot 0
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            20, 75,  -999,     49,   999,   95,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\xff\x00\x01\x01\x01\x04\x00\x00\x00\x00',

            # big foot 1
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            50, 58,  -999,     49,   999,   95,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\xff\x00\x01\x01\x03\x04\x00\x00\x00\x00',

            # big foot 2
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            80, 65,  -999,     49,   999,   95,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\xff\x00\x01\x01\x01\x04\x00\x00\x00\x00',

            # big foot 3
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            110, 65,  -999,     49,   999,   95,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\xff\x00\x01\x01\x03\x04\x00\x00\x00\x00',

            # big foot 0 (trigger 0a)
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,                   by2
            0,   15,  0,     -999,       glob.TILEMAP_W*8, 999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x00\x0a\x01\x00\x01\x02\x04\x00\x01\x00\x00',

            # big foot 1  (trigger 0a)
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            20, 35,  0,     -999,       glob.TILEMAP_W*8, 999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x01\x0a\x01\x00\x01\x02\x04\x00\x01\x00\x00',
            
            # big foot 2  (trigger 0a)
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            40, 60,  0,     -999,       glob.TILEMAP_W*8, 999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x02\x0a\x01\x00\x01\x02\x04\x00\x01\x00\x00',

            # big foot 3  (trigger 0a)
            # Bitmaps
            (
                # bitmap         offset
                data.bigFootSurf_f0, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            60, 85,  0,     -999,       glob.TILEMAP_W*8, 999,
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x03\x0a\x01\x00\x01\x02\x04\x00\x01\x00\x00',


            # WakeUp
            # Bitmaps
            (
                # bitmap         offset
                data.wakeUpSurf_f0, (0,0), 
                data.wakeUpSurf_f1, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            125, 85,   -999,  -999,   999,   999, 
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x04\xff\x00\x00\x0a\x02\x01\x00\x00\x00\x00',

            # WakeUp (trigger 0a)
            # Bitmaps
            (
                # bitmap         offset
                data.wakeUpSurf_f0, (0,0), 
                data.wakeUpSurf_f1, (0,0), 
            ),
            # wx, wy,  bx1,   by1,      bx2,   by2
            125, 85,   -999,  20,   999,   999, 
            #   id trg  vx  vy adu dir del bTy hfl vfl coi
            b'\x04\x0a\x00\x01\x0a\x01\x01\x02\x00\x00\x00',
        ),
    ),
)


#gc.collect()
#print ("free, after rooms",gc.mem_free())

